#!/bin/sh

RED='\033[0;31m'
CYAN='\033[0;36m'
YELLOW='\033[1;33m'
GREEN='\033[0;32m'
WHITE='\033[1;37m'
NC='\033[0m' # No Color

echo "Building '${CYAN}BOOST${NC}' for ${WHITE}Debug${NC}(${LINK_TYPE})"

cd ../../external_dependencies/boost
 
./b2 cxxflags="-fPIC" --layout=system variant=debug link=${LINK_TYPE} address-model=64 --with-system --with-serialization --with-random

cd ../../build_scripts/linux

